/*

JSON-stat for Eurostat v. 0.1.9 (requires JJT ES6 module) (ES6 module)
https://json-stat.com
https://github.com/badosa/JSON-stat/tree/master/eurostat

Copyright 2019 Xavier Badosa (https://xavierbadosa.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
or implied. See the License for the specific language governing
permissions and limitations under the License.

*/
import{JSONstat}from"../jsonstat/export.mjs";
const version="0.1.9",ELANG="en",EVERSION="2.1";function hasProp(e,r){return Object.prototype.hasOwnProperty.call(e,r)}function getURL(e){if(e.dataset){const r=e.filter||null,t=e.lang||ELANG;let a=`https://ec.europa.eu/eurostat/wdds/rest/data/v${e.version||EVERSION}/json/${t}/${e.dataset}`,s=[];return r&&(Object.keys(r).forEach(e=>{r[e].forEach(r=>{s.push(`${e}=${r}`)})}),a+="?"+s.join("&")),a}return null}function lastPeriodQuery(e){const r=JSON.parse(JSON.stringify(e));return hasProp(r,"filter")?(delete r.filter.time,r.filter.lastTimePeriod=["1"]):r.filter={lastTimePeriod:["1"]},r.class="query",r.lang=e.lang?e.lang:ELANG,r.version=e.version?e.version:EVERSION,r}function simpleQuery(e,r){const t=JSON.parse(JSON.stringify(e));return hasProp(t,"filter")&&(Object.keys(t.filter).forEach(e=>{t.filter[e]=t.filter[e].slice(0,1)}),!0===r&&(delete t.filter.time,t.filter.lastTimePeriod=["1"])),hasProp(t,"label")&&hasProp(t.label,"category")&&(Object.keys(t.label.category).forEach(e=>{t.label.category[e]=t.label.category[e].slice(0,1)}),!0===r&&delete t.label.category.time),t.class="query",t.lang=e.lang?e.lang:ELANG,t.version=e.version?e.version:EVERSION,t}function removeParamQuery(e,r){const t=JSON.parse(JSON.stringify(e)),a=hasProp(t,"filter"),s=hasProp(t,"label"),l=s&&hasProp(t.label,"category"),o=s&&hasProp(t.label,"dimension");return r.forEach(e=>{a&&delete t.filter[e],s&&(l&&delete t.label.category[e],o&&delete t.label.dimension[e])}),t.class="query",t.lang=e.lang?e.lang:ELANG,t.version=e.version?e.version:EVERSION,t}function removeTimeQuery(e){return removeParamQuery(e,["time","lastTimePeriod","sinceTimePeriod"])}function querify(e,r,t){return{class:"query",dataset:null,filter:e,lang:r||ELANG,version:t||EVERSION}}function addParamQuery(e,r,t){void 0===t&&(t=Object.keys(r),r=querify(r));const a=JSON.parse(JSON.stringify(e)),s=hasProp(r,"filter"),l=hasProp(r,"label")&&hasProp(r.label,"category");return t.forEach(e=>{s&&hasProp(r.filter,e)&&(hasProp(a,"filter")||(a.filter={}),a.filter[e]=r.filter[e]),l&&hasProp(r.label.category,e)&&(hasProp(a,"label")?hasProp(a.label,"category")||(a.label.category={}):a.label={},a.label.category[e]=r.label.category[e])}),a.class="query",a.lang=e.lang?e.lang:ELANG,a.version=e.version?e.version:EVERSION,a}function getStatusLabel(e,r){return e.extension.status.label[r]}function setRole(e){e.role={geo:[],time:[],metric:[],classification:[]},e.id.forEach(r=>{switch(e.Dimension(r).role="time"===r||"geo"===r?r:"classification",r){case"geo":case"time":e.role[r].push(r);break;case"unit":case"s_adj":e.role.metric.push(r);break;default:e.role.classification.push(r)}})}function getEmptyDataset(e){const r=Object.keys(e.filter),t=r.map(r=>e.filter[r].length),a={};r.forEach(r=>{a[r]={label:e.label.dimension[r],category:{index:e.filter[r],label:{}}},e.filter[r].forEach((t,s)=>{Object.defineProperty(a[r].category.label,t,{value:e.label.category[r][s]})})});const s={version:"2.0",class:"dataset",label:e.label.dataset,id:r,size:t,dimension:a,value:[]},l=JSONstat(s);return EuroJSONstat.setRole(l),l}const isNode=new Function("try {return this===global;}catch(e){return false;}");function fetchDataset(e){let r;if(r=isNode()?require("node-fetch"):"function"!=typeof fetch?function(){window.alert("JSONstat for Eurostat: Old browsers are not supported, sorry. Use a polyfill for Fetch and Promise.")}:fetch,e)return r("string"==typeof e?e:getURL(e)).then(e=>e.json()).then(e=>{if(e.error)return{class:"error",status:e.error.status,label:e.error.label};{const r=JSONstat(e);return"dataset"===r.class?(setRole(r),r):{class:"error",status:"422",label:"Unprocessable Entity"}}})}function fetchQuery(e,r){const t=!1!==r?lastPeriodQuery(e):e;return fetchDataset(t).then(e=>{if("error"===e.class)return e;const r={},a={},s={};return e.id.forEach(t=>{const l=e.Dimension(t);a[t]=l.label,r[t]=l.id,s[t]=l.Category().map(e=>e.label)}),{class:"query",dataset:t.dataset,filter:r,label:{dataset:e.label,dimension:a,category:s},lang:t.lang||ELANG,version:t.version||EVERSION}})}function fetchFullQuery(e,r){return fetchQuery(addParamQuery(e,"string"==typeof r?{geo:[r]}:{filterNonGeo:["1"]})).then(e=>"error"===e.class?e:fetchQuery(removeParamQuery(simpleQuery(e),["time","geo"]),!1).then(r=>"error"===r.class?r:addParamQuery(e,r,["time","geo"])))}export{JSONstat,simpleQuery,lastPeriodQuery,addParamQuery,removeParamQuery,removeTimeQuery,fetchQuery,fetchFullQuery,fetchDataset,getURL,getStatusLabel,getEmptyDataset,setRole,version};
